︠7951253f-bf30-4e35-bac0-46fb23aac88e︠
######################################################################################
# Theory
#
#
# P(1) = 4/52
# P(2) = (48/52) * (4/51)
# P(3) = (48/52) * (47/51) * (4/50)
# P(4) = (48/52) * (47/51) * (46/50) * (4/49)
# ......
# P(k) = (48/52) * (47/51) *...* [(48-k+2)/(52-k+2)] * [4/(52-k+1)]
︡b3ae49af-a1e5-405e-9190-fe22f4eaba46︡{"stdout": "(k>=2)\n# ......\n# P(49) = (48/52) * (47/51) *...* (1/5) * (4/4)\n#\n# \n# Average = P(1)*1 + P(2)*2 + P(3)*3 +...+ P(48)*48 + P(49)*49\n#\n# As a result, the most frequently output will be 1\n#              the least frequently output will be 49\n#              the average output will be \"Average\".\n#\n######################################################################################\n\ndef compute_p(k):\n    result = 1\n    if k == 1:\n        return 4/52\n    elif k == 0:\n        return 0\n    else:\n        for i in range(k-1):\n            result = result * ((48-i)/(52-i))\n        result = result * (4/(52-k+1))\n        return result\n\n\nP_list = []\navg = 0\n\nfor i in range(50):\n    p = compute_p(i)\n    P_list.append(p)\n\nfor i in range(len(P_list)):\n    avg = avg + i*(P_list[i])\n\nprint (float(avg)) # The average\n///\n10.6"}︡
︠92927178-a6d5-4a26-a19c-3f0955d2aca3︠
#
︡1e6e57ab-ad3a-439a-82cc-2b6d891ea396︡︡
︠190d0a36-c8ee-4505-8cfb-93d828910893︠
######################################################################################
# Experiment
######################################################################################

def create_deck():
   """Create a deck of cards
      ranks is a list of the ranks
      suits is a list of the suits"""
   ranks = ['A', '2', '3', '4', '5', '6', '7', '8', '9', '10', 'J', 'Q', 'K']
   suits = ['C', 'D', 'H', 'S']
   deck = []
   for suit in suits:
      for rank in ranks:
         card = (rank, suit)
         deck.append(card)
   return deck

def shuffle_deck(deck):
   """Shuffle the deck by swapping pairs of cards"""
   for i in range(51):     # i ranges from 0 to 50
      j = randint(i+1,51)  # j ranges from i+1 to 51
      deck[i], deck[j] = deck[j], deck[i]

def FirstAce(deck):
   for i in range(len(deck)):
      if deck[i][0] == 'A':
         return i+1

def create_list():
   l = []
   for i in range(50):
      l.append(0)
   return l

deck = create_deck()
l = create_list()
avg = 0.0

for i in xrange(10000):
	shuffle_deck(deck)
	c = FirstAce(deck)
	l[c] = l[c] + 1

for i in range(1,len(l)):
	print i,":",l[i]
        avg = avg + l[i]*i

avg = avg / 10000
print "\nAverage: ",avg
︡ba5db592-3dc7-4454-8f23-f422f20ccf4b︡{"stdout": "1 : 761\n2 : 702\n3 : 650\n4 : 644\n5 : 574\n6 : 591\n7 : 518\n8 : 538\n9 : 461\n10 : 421\n11 : 362\n12 : 368\n13 : 346\n14 : 321\n15 : 281\n16 : 277\n17 : 244\n18 : 222\n19 : 222\n20 : 168\n21 : 151\n22 : 149\n23 : 136\n24 : 116\n25 : 132\n26 : 95\n27 : 91\n28 : 73\n29 : 60\n30 : 55\n31 : 56\n32 : 43\n33 : 33\n34 : 38\n35 : 18\n36 : 15\n37 : 18\n38 : 15\n39 : 9\n40 : 13\n41 : 7\n42 : 4\n43 : 0\n44 : 1\n45 : 1\n46 : 0\n47 : 0\n48 : 0\n49 : 0\n\nAverage:  10.6491000000000"}︡
